// Fichier ConversionChaines.cpp

#include "ConversionChaines.h"
#include <string>
using std::basic_string;
using std::string;
using std::wstring;
#include <algorithm>
using std::transform;
#include <locale>
using std::locale;

template <class CDest, class CSrc>
   basic_string<CDest> rebuild (const basic_string<CSrc> &s)
      { return basic_string<CDest> (s.begin (), s.end ()); }

wstring StringToWString (const string &s)
   { return rebuild<wstring::value_type>(s) ; }

string WStringToString (const wstring &s)
   { return rebuild<string::value_type>(s) ; }

template <class C>
   struct ConvertirMajuscules
   {
      C operator () (const C c)
         { return toupper (c, locale ("")); }
   };

template <class C>
   basic_string<C> _Majuscules (const basic_string<C> &s)
   {
      basic_string<C> Resultat;
      Resultat.resize (s.length ());
      transform (s.begin (), s.end (), Resultat.begin (), ConvertirMajuscules<C> ());
      return Resultat;
   }

// Retourne la version majuscule du texte en paramtre
string Majuscules (const string &s)
   { return _Majuscules (s); }
